"""WAeUP portal certificates
"""
import grok
from zope.component.interfaces import IFactory
from waeup.interfaces import ICertificate, ICertificateContainer

class Certificate(grok.Container):
    """A certificate.
    """
    grok.implements(ICertificate)

    def __init__(self, code=u'NA', title=u'Unnamed Certificate', level=None,
                 credits = 0, passmark=40, semester=1):
        self.code = code
        self.title = title
        self.level = level
        self.credits = credits
        self.passmark = passmark
        self.semester = semester

class CertificateFactory(grok.GlobalUtility):
    """A factory for certificates.
    """
    grok.implements(IFactory)
    grok.name(u'waeup.Certificate')
    title = u"Create a new certificate.",
    description = u"This factory instantiates new certificate instances."

    def __call__(self):
        return Certificate()

    def getInterfaces(self):
        return implementedBy(Certificate)
